;; -*-emacs-lisp-*-
;;
;; Emacs startup file for the Debian GNU/Linux ess package
;;
;; Originally contributed by Nils Naumann <naumann@unileoben.ac.at>
;; Modified by Dirk Eddelbuettel <edd@debian.org>
;; Adapted for dh-make by Jim Van Zandt <jrv@vanzandt.mv.com>

;;  The following code fixes bug #440194 - thanks to Peter S Galbraith <psg@debian.org> 
;;  skip loading when
;;  not ess is fully installed, as this file still exists when the
;;  package is removed but not purged.

(cond
 ((not (file-exists-p "/usr/share/emacs/site-lisp/ess"))
  (message
   "Package ess removed but not purged.  Skipping setup."))
 ((not (file-exists-p (concat "/usr/share/"
                              (symbol-name debian-emacs-flavor)
                              "/site-lisp/ess/ess-site.elc")))
  (message "Package ess not fully installed.  Skipping setup."))
 (t 
  ;; The ess package follows the Debian/GNU Linux 'emacsen' policy and
  ;; byte-compiles its elisp files for each 'emacs flavor' (emacs19,
  ;; xemacs19, emacs20, xemacs20...).  The compiled code is then
  ;; installed in a subdirectory of the respective site-lisp directory.
  ;; We have to add this to the load-path:
  (debian-pkg-add-load-path-item
   (concat "/usr/share/" (symbol-name debian-emacs-flavor) "/site-lisp/ess"))

  ;; As ess_5.12-1 we also link the uncompiled code into that directory so no need to load it
  ;; Put the uncompiled code in the path too 
  ;; (setq load-path (cons  (concat "/usr/share/"
  ;; 				 (symbol-name debian-emacs-flavor)
  ;; 				 "/site-lisp/ess") load-path ))
  (require 'ess-site)
  )
 )

